#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void print_box(char* msg)
{
    int msg_len = strlen(msg) + 4;
    for (int i = 0; i < msg_len; i++)
        putc('-', stdout);
    printf("\n| ");
    printf("%s", msg);
    printf(" |\n");
    for (int i = 0; i < msg_len; i++)
        putc('-', stdout);
    printf("\n\n");
}

void print_flag() {
    FILE *fptr = fopen("flag.txt", "r");
    if(fptr == NULL) {
        printf("Gick inte att öppna flag.txt... Om du kör mot servern, kontakta en admin.");
        exit(0);
    }

    char c;
    while((c = getc(fptr)) != EOF) {
        putchar(c);
    }
    fflush(stdout);
    fclose(fptr);
}

int main(int argc, char **argv) {
    setvbuf(stdout, 0, 2, 0);
    setvbuf(stdin, 0, 2, 0);

    char extra_intro_message[256] = "";
    char order[200] = "<Ingen>";
    char name[64] = "Användare";

    printf("Välkommen till Staketstolpar ABs CLI-baserade beställningsgränssnitt!\n");
    printf("=====================================================================\n");
    printf("Fyll i ditt namn med hjälp av menyn och ange din beställning som fritext så behandlar vi den så snart vi kan. %s\n\n", extra_intro_message);

    while (1)
    {
        printf("Namn:\n");
        printf(name);
        printf("\n\n");

        printf("Beställning:\n");
        print_box(order);

        printf("(a)vsluta, ändra (n)amn, ändra (b)eställning? ");
        char action[3] = "";

        if (!fgets(action, sizeof(action), stdin))
            exit(0);
        switch (action[0])
        {
            case 'a':
            {
                puts("Hejdå!\n");
                exit(0);
            }

            case 'n':
            {
                printf("Ange nytt namn: ");
                char* new_name;
                size_t len = 0;
                getline(&new_name, &len, stdin);
                new_name[strcspn(new_name, "\n")] = 0;

                char* c = new_name;
                do
                {
                    if (*c == '%')
                        *c = ' ';
                } while (*c++);

                strncpy(name, new_name, sizeof(name));
                break;
            }

            case 'b':
            {
                printf("Ange ny beställningstext: ");
                char* new_order;
                size_t len = 0;
                getline(&new_order, &len, stdin);
                new_order[strcspn(new_order, "\n")] = 0;

                char* c = new_order;
                do
                {
                    if (*c == "%")
                        *c = ' ';
                } while (*c++);

                strncpy(order, new_order, sizeof(order));
                break;
            }
            default:
                continue;
        }
    }

    return 0;
}
